<!DOCTYPE html>
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" xmlns:th="https://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link th:replace="header.html :: css">
    <title th:replace="header :: title(Credentials)">Files</title>
</head>
<body class="p-3 mb-2 bg-light text-black">
<div class="container">
    <div th:replace="header.html :: logout"></div>
    <nav th:replace="header.html :: navigation(credentials)"></nav>
    <p></p>
    <p></p>
    <div th:if="${param.save != null and param.save[0] == 'success'}"class="alert alert-success alert-dismissible fade show" role="alert">
        Your credentials have been saved.
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div th:if="${param.delete != null and param.delete[0] == 'success'}" class="alert alert-success alert-dismissible fade show" role="alert">
        The selected credential has been successfully deleted.
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div th:if="${param.save != null and param.save[0] == 'edit-success'}" class="alert alert-success alert-dismissible fade show" role="alert">
        Your changes have been saved.
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div th:if="${param.error != null}" class="alert alert-danger alert-dismissible fade show" role="alert">
        An error has occurred. Please try again.
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="tab-content" id="nav-tabContent">
        <div class="tab-pane fade show active" id="nav-credentials" th:fragment="content" role="tabpanel" aria-labelledby="nav-credentials-tab">
        <button style="margin: 0.25em;" type="button" id="add-credentials-button" class="btn btn-info float-right" onclick="showCredentialModal()">
            + Add a New Credential
        </button>
        <div class="table-responsive">
        <table class="table table-striped" th:object="${credentials}" id="credentialTable">
            <thead>
            <tr>
                <th style="width: 20%" scope="col"></th>
                <th style="width: 35%" scope="col">URL</th>
                <th style="width: 20%" scope="col">Username</th>
                <th style="width: 25%" scope="col">Password</th>
            </tr>
            </thead>
            <tbody th:remove="all-but-first">
            <tr class="credentials" th:each="credential : ${credentialList}">
                <td>
                    <button type="submit" class="btn btn-success" id="edit-credential-button">Edit</button>
                    <input type="hidden" name="credentialId" id="credentialIdEdit" th:value="${credential.id}">
                    <form action="#" th:action="@{'/credentials/delete/' + ${credential.getId()}}" method="POST" hidden="true" aria-hidden="true">
                        <button type="submit" class="btn btn-danger" id="deleteCredential" >Delete</button>
                    </form>
                    <button type="submit" class="btn btn-danger" id="delete-credential-button" onclick="$('#deleteCredential').click();">Delete</button>
                </td>
                <th id="credential-url-display" th:text="${credential.url}" scope="row">Example Credential URL</th>
                <td id="credential-username-display" th:text="${credential.username}">Example Credential Username</td>
                <td id="credential-password-display" th:text="${credential.password}">Example Credential Password</td>
            </tr>
            <tr class="credentials">
                <td>
                    <button type="button" class="btn btn-success">Edit</button>
                    <a class="btn btn-danger">Delete</a>
                </td>
                <th scope="row">Example Credential URL</th>
                <td>Example Credential Username</td>
                <td>Example Credential Password</td>
            </tr>
            </tbody>
        </table>
    </div>

        <div class="modal fade" id="credentialModal" tabindex="-1" role="dialog" aria-labelledby="credentialModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="credentialModalLabel">Credential</h5>
                    <button type="button" id="close-modal-button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form action="#" th:action="@{/credentials}" method="POST" th:object="${credential}">
                        <input type="hidden" name="id" id="credential-id">
                        <div class="form-group">
                            <label for="credential-url" class="col-form-label">URL</label>
                            <input type="text" name= "url" class="form-control" id="credential-url" maxlength="100" th:field="${credential.url}" required>
                        </div>
                        <div class="form-group">
                            <label for="credential-username" class="col-form-label">Username</label>
                            <input type="text" name= "username" class="form-control" id="credential-username" th:field="${credential.username}" maxlength="30" required>
                        </div>
                        <div class="form-group">
                            <label for="credential-password" class="col-form-label">Password</label>
                            <input type="text" name= "password" class="form-control" id="credential-password" th:field="${credential.password}" maxlength="30" required>
                        </div>
                        <button id="credentialSubmit" type="submit" class="d-none"></button>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" id="cancel-button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button id="save-button" type="button" class="btn btn-primary" onclick="$('#credentialSubmit').click();">Save changes</button>
                </div>
            </div>
        </div>
    </div>
    </div>
    </div>
</div>
<div th:replace="header.html :: scripts"></div>
<script type="text/javascript">

    $(document).ready(function () {
        $('#edit-credential-button').on('click', function () {
            let id = $('#credentialIdEdit').val();
            console.log(id + " is ID")
            $.ajax({
                url: "/credentials/" + id
            }).then(function (data) {
                console.log(data)
                $('#credential-id').val(data.id);
                $('#credential-url').val(data.url);
                $('#credential-username').val(data.username);
                $('#credential-password').val(data.password);
                let credentialModal = new Modal('credentialModal');
                credentialModal.show();
            });
        });
    });

    // For opening the credentials modal
    function showCredentialModal(credentialId, url, username, password) {
        $('#credential-id').val(credentialId ? credentialId : '0');
        $('#credential-url').val(url ? url : '');
        $('#credential-username').val(username ? username : '');
        $('#credential-password').val(password ? password : '');
        let credentialModal = new Modal('credentialModal');
        credentialModal.show();
    }
</script>
</body>
</html>